#ifndef CPGL_H
#define CPGL_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <SDL.h>
#ifdef __APPLE__
    #include <OpenGL/glu.h>
    #include <OpenGL/glext.h>
#else
    #include <GL/glu.h>
    #include <GL/glext.h>
    #include <GL/glx.h>
    #include <GL/glxext.h>
#endif

#if !defined(__APPLE__) && !defined(_WIN32)

extern PFNGLCREATEPROGRAMOBJECTARBPROC     glCreateProgramObjectARB;
extern PFNGLCREATESHADEROBJECTARBPROC      glCreateShaderObjectARB;
extern PFNGLSHADERSOURCEARBPROC            glShaderSourceARB;
extern PFNGLCOMPILESHADERARBPROC           glCompileShaderARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC    glGetObjectParameterivARB;
extern PFNGLATTACHOBJECTARBPROC            glAttachObjectARB;
extern PFNGLGETINFOLOGARBPROC              glGetInfoLogARB;
extern PFNGLLINKPROGRAMARBPROC             glLinkProgramARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC        glUseProgramObjectARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC      glGetUniformLocationARB;
extern PFNGLUNIFORM1FARBPROC               glUniform1f;
extern PFNGLUNIFORM2FARBPROC               glUniform2f;
extern PFNGLUNIFORM3FARBPROC               glUniform3f;
extern PFNGLUNIFORM1FVARBPROC              glUniform1fv;
extern PFNGLUNIFORM2FVARBPROC              glUniform2fv;
extern PFNGLUNIFORM3FVARBPROC              glUniform3fv;

#define glGetProcAddress(x) (*glXGetProcAddressARB)((const GLubyte*) x)

#endif


#define DESIRED_FPS 60.0

#endif

